# Esercizio Rettangolo
# DATI
param nP;
set P := 1..nP;
set R := 0..3;
param x {P};
param y {P};

# VARIABILI
var a {R};
var b {R};
var c {R};
var L1 >=0;
var L2 >=0;

# VINCOLI
# Noormalizzazione dei coefficienti delle rette
subject to Normalizzazione {j in R}:
  a[j]^2 + b[j]^2 = 1;

# Perpendicolarit
subject to Perpendicolare:
  a[0]*a[1] + b[0]*b[1] = 0;

# Antiparallelismo
subject to Antiparallele {j in R: j<=1}:
  a[j]*a[j+2] + b[j]*b[j+2] = -1;

# Copertura dei punti
subject to Copertura {i in P, j in R}:
  a[j]*x[i] + b[j]*y[i] + c[j] >= 0;

# Definizione lati
subject to Lato1: L1 = c[0]+c[2];
subject to Lato2: L2 = c[1]+c[3];

# OBIETTIVO
# Minimizzare l'area
minimize z: L1*L2;

##################
data;
param nP := 10;
param: x  y :=
1     -7 -2
2     -3  5
3     -4 -5
4     10  5
5     11  2
6      6  9
7      0 -6
8     -6  2
9      9  0
10    -7  0;

var:	a	b	c :=
0		1   0	-100
1		0  -1	-100
2	   -1	0	-100
3		0	1	-100;

end;
